package de.jottyfan.timetrack.spring.done;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 
 * @author henkej
 *
 */
public class SummaryBean implements Serializable {
	private static final long serialVersionUID = 1L;

	private final List<DoneBean> list;
	
	public SummaryBean(List<DoneBean> list) {
		this.list = list;
	}

	/**
	 * @return the start
	 */
	public String getStart() {
		LocalDateTime found = LocalDate.now().atTime(23, 59);
		for (DoneBean bean : list) {
			LocalDateTime ldt = bean.getTimeFrom();
			if (ldt != null && ldt.isBefore(found)) {
				found = ldt;
			}
		}
		return String.format("%02d:%02d", found.getHour(), found.getMinute() % 60);
	}

	/**
	 * @return the end
	 */
	public String getEnd() {
		LocalDateTime found = LocalDate.now().atTime(0, 0);
		for (DoneBean bean : list) {
			LocalDateTime ldt = bean.getTimeUntil();
			if (ldt != null && found.isBefore(ldt)) {
				found = ldt;
			}
		}
		return String.format("%02d:%02d", found.getHour(), found.getMinute() % 60);
	}

	/**
	 * @return the total
	 */
	public String getTotal() {
		return "TODO";
	}

	/**
	 * @return the pause
	 */
	public String getPause() {
		return "TODO";
	}

	/**
	 * @return the overdue
	 */
	public String getOverdue() {
		return "TODO";
	}
}
