package de.jottyfan.timetrack.modules.done;

/**
 * 
 * @author henkej
 *
 */
public class WholeDaySummaryBean {
	private final String startTime;
	private final String endTime;
	private final String workTime;
	private final String breakTime;
	private final Integer dayrequests;

	public WholeDaySummaryBean(String startTime, String endTime, String workTime, String breakTime, Integer dayrequests) {
		super();
		this.startTime = startTime;
		this.endTime = endTime;
		this.workTime = workTime;
		this.breakTime = breakTime;
		this.dayrequests = dayrequests == null ? 468 : dayrequests; // 7:48 by default
	}

	public String getOvertime() {
		if (workTime != null && !workTime.trim().isEmpty() && workTime.contains(":")) {
			try {
				Integer hours = Integer.valueOf(workTime.substring(0, workTime.indexOf(":")));
				Integer minutes = Integer.valueOf(workTime.substring(workTime.indexOf(":") + 1));
				Integer wholeMinutes = hours * 60 + minutes;
				Integer overtime = wholeMinutes - dayrequests;
				Integer overtimeHours = overtime / 60;
				Integer overtimeMinutes = overtime % 60;
				StringBuilder buf = new StringBuilder();
				if (overtime < 0) {
					buf.append("-");
					overtimeHours *= -1;
					overtimeMinutes *= -1;
				}
				buf.append(String.format("%02d", overtimeHours));
				buf.append(":");
				buf.append(String.format("%02d", overtimeMinutes));
				return buf.toString();
			} catch (NumberFormatException e) {
				return "";
			}
		}
		Integer requestHours = dayrequests / 60;
		Integer requestMinutes = dayrequests % 60;
		StringBuilder buf = new StringBuilder("-");
		buf.append(requestHours < 10 ? "0" : "").append(requestHours);
		buf.append(":");
		buf.append(requestMinutes < 10 ? "0" : "").append(requestMinutes);
		return buf.toString();
	}

	public String getStartTime() {
		return startTime;
	}

	public String getEndTime() {
		return endTime;
	}

	public String getWorkTime() {
		return workTime;
	}

	public String getBreakTime() {
		return breakTime;
	}
}
